diff --git a/src/backend/storage/smgr/page_compression.c b/src/backend/storage/smgr/page_compression.c
new file mode 100644
index 0000000000..98a5bf66fe
--- /dev/null
+++ b/src/backend/storage/smgr/page_compression.c
@@ -0,0 +1,466 @@
+/*
+ * page_compression.c
+ *		Routines for page compression
+ *
+ *
+ * Copyright (c) 2022, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *	  src/backend/storage/smgr/page_compression.c
+ */
+#include "postgres.h"
+
+#include "miscadmin.h"
+#include "storage/bufmgr.h"
+#include "storage/fd.h"
+#include "utils/timestamp.h"
+
+#include "storage/page_compression.h"
+#include "storage/page_compression_impl.h"
+
+static BlockNumber getsegno(const char *path_pca);
+
+/*
+ * Returns segment number for specified pca file.
+ *
+ */
+static BlockNumber
+getsegno(const char *path_pca)
+{
+	int			i;
+	BlockNumber segno = (BlockNumber) 0;
+	int			pathlen = strlen(path_pca);
+	const char *dot_pos = NULL;
+
+	for (i = pathlen - 5; i >= 0; i--)
+	{
+		if (path_pca[i] < '0' && path_pca[i] > '9')
+			break;
+
+		if (path_pca[i] == '.')
+		{
+			dot_pos = &path_pca[i];
+			break;
+		}
+	}
+
+	if (dot_pos)
+		segno = atol(dot_pos);
+
+	return segno;
+}
+
+/*
+ * errcode_for_dynamic_shared_memory --- add SQLSTATE error code to the current error
+ *
+ * The SQLSTATE code is chosen based on the saved errno value.  We assume
+ * that the failing operation was some type of mmap access.
+ *
+ * NOTE: the primary error message string should generally include %m
+ * when this is used.
+ */
+int
+errcode_for_dynamic_shared_memory(void)
+{
+	if (errno == EFBIG || errno == ENOMEM)
+		return errcode(ERRCODE_OUT_OF_MEMORY);
+	else
+		return errcode_for_file_access();
+}
+
+/*
+ * Check data consistency of pca file and if inconsistent try to repair it via
+ * the pcd file.
+ *
+ */
+void
+check_and_repair_compress_address(PageCompressHeader *pcmap, uint16 chunk_size, uint8 algorithm,
+								  const char *path, int fd_pcd, const char *path_pcd)
+{
+	int			i,
+				unused_chunks;
+	BlockNumber blocknum,
+				segno;
+	uint32		nblocks,
+				allocated_chunks,
+				real_blocks;
+	BlockNumber *global_chunknos;
+	char		last_recovery_start_time_buf[sizeof(TimestampTz)];
+	char		start_time_buf[sizeof(TimestampTz)];
+	struct stat fst;
+	bool		need_check = false;
+	int			total_allocated_chunks;
+	PageCompressAddr *pcaddr;
+
+	unused_chunks = 0;
+	real_blocks = 0;
+
+	/* if the relation had been checked in this startup, skip */
+	memcpy(last_recovery_start_time_buf, &pcmap->last_recovery_start_time, sizeof(TimestampTz));
+	memcpy(start_time_buf, &PgStartTime, sizeof(TimestampTz));
+	for (i = 0; i < sizeof(TimestampTz); i++)
+	{
+		if (start_time_buf[i] != last_recovery_start_time_buf[i])
+		{
+			need_check = true;
+			break;
+		}
+	}
+	if (!need_check)
+		return;
+
+	/* read count of allocated chunks */
+	if (stat(path_pcd, &fst) < 0)
+	{
+		ereport(ERROR,
+				(errcode_for_file_access(),
+				 errmsg("could not stat file \"%s\": %m", path_pcd)));
+	}
+	total_allocated_chunks = fst.st_size / chunk_size;
+
+	/* check header of page compression address file */
+	if (pcmap->chunk_size != chunk_size || pcmap->algorithm != algorithm)
+	{
+		/*
+		 * reinitialize header of pca file if it is invalid and
+		 * zero_damaged_pages is on
+		 */
+		if (zero_damaged_pages)
+		{
+			ereport(WARNING,
+					(errcode(ERRCODE_DATA_CORRUPTED),
+					 errmsg("invalid chunk_size %u or algorithm %u in header of file \"%s\", and reinitialized it.",
+							pcmap->chunk_size, pcmap->algorithm, path)));
+
+			pcmap->algorithm = algorithm;
+			pcmap->chunk_size = chunk_size;
+			pg_atomic_write_u32(&pcmap->nblocks, 0);
+		}
+		else
+			ereport(ERROR,
+					(errcode(ERRCODE_DATA_CORRUPTED),
+					 errmsg("invalid chunk_size %u or algorithm %u in header of file \"%s\"",
+							pcmap->chunk_size, pcmap->algorithm, path)));
+	}
+
+	segno = getsegno(path);
+	nblocks = pg_atomic_read_u32(&pcmap->nblocks);
+	allocated_chunks = pg_atomic_read_u32(&pcmap->allocated_chunks);
+	global_chunknos = palloc0(sizeof(BlockNumber) * MAX_PAGE_COMPRESS_CHUNK_NUMBER(chunk_size));
+
+	/* check address data of every pages */
+	for (blocknum = segno * ((BlockNumber) RELSEG_SIZE); blocknum < (segno + 1) * ((BlockNumber) RELSEG_SIZE); blocknum++)
+	{
+		pcaddr = GetPageCompressAddr(pcmap, chunk_size, blocknum);
+
+		/* skip when found first zero filled block after nblocks */
+		if (blocknum % RELSEG_SIZE >= (BlockNumber) nblocks && pcaddr->allocated_chunks == 0)
+			break;
+
+		/* check allocated_chunks for one page */
+		if (pcaddr->allocated_chunks > MaxChunksPreCompressedPage(chunk_size))
+		{
+			if (zero_damaged_pages)
+			{
+				ereport(WARNING,
+						(errcode(ERRCODE_DATA_CORRUPTED),
+						 errmsg("invalid allocated chunks %u of block %u in file \"%s\", and zero the block",
+								pcaddr->allocated_chunks, blocknum, path)));
+
+				MemSet(pcaddr, 0, SizeOfPageCompressAddr(chunk_size));
+				continue;
+			}
+			else
+			{
+				pfree(global_chunknos);
+				ereport(ERROR,
+						(errcode(ERRCODE_DATA_CORRUPTED),
+						 errmsg("invalid allocated chunks %u of block %u in file \"%s\"",
+								pcaddr->allocated_chunks, blocknum, path)));
+			}
+		}
+
+		/* check nchunks for one page */
+		if (pcaddr->nchunks > pcaddr->allocated_chunks)
+		{
+			if (zero_damaged_pages)
+			{
+				ereport(WARNING,
+						(errcode(ERRCODE_DATA_CORRUPTED),
+						 errmsg("nchunks %u exceeds allocated_chunks %u of block %u in file \"%s\", and zero the block",
+								pcaddr->nchunks, pcaddr->allocated_chunks, blocknum, path)));
+
+				MemSet(pcaddr, 0, SizeOfPageCompressAddr(chunk_size));
+				continue;
+			}
+			else
+			{
+				pfree(global_chunknos);
+				ereport(ERROR,
+						(errcode(ERRCODE_DATA_CORRUPTED),
+						 errmsg("nchunks %u exceeds allocated_chunks %u of block %u in file \"%s\"",
+								pcaddr->nchunks, pcaddr->allocated_chunks, blocknum, path)));
+			}
+		}
+
+		/* check chunknos for one page */
+		for (i = 0; i < pcaddr->allocated_chunks; i++)
+		{
+			/* check for invalid chunkno */
+			if (pcaddr->chunknos[i] == 0 || pcaddr->chunknos[i] > MAX_PAGE_COMPRESS_CHUNK_NUMBER(chunk_size))
+			{
+				if (zero_damaged_pages)
+				{
+					ereport(WARNING,
+							(errcode(ERRCODE_DATA_CORRUPTED),
+							 errmsg("invalid chunk number %u of block %u in file \"%s\", and zero the block",
+									pcaddr->chunknos[i], blocknum, path)));
+
+					MemSet(pcaddr, 0, SizeOfPageCompressAddr(chunk_size));
+					break;
+				}
+				else
+				{
+					pfree(global_chunknos);
+					ereport(ERROR,
+							(errcode(ERRCODE_DATA_CORRUPTED),
+							 errmsg("invalid chunk number %u of block %u in file \"%s\"",
+									pcaddr->chunknos[i], blocknum, path)));
+				}
+			}
+
+			/* check for duplicate chunkno */
+			if (global_chunknos[pcaddr->chunknos[i] - 1] != 0)
+			{
+				if (zero_damaged_pages)
+				{
+					int			j;
+					PageCompressAddr *pcaddr_dup = GetPageCompressAddr(pcmap, chunk_size, global_chunknos[pcaddr->chunknos[i] - 1] - 1);
+
+					ereport(WARNING,
+							(errcode(ERRCODE_DATA_CORRUPTED),
+							 errmsg("chunk number %u of block %u duplicate with block %u in file \"%s\", and zero the two blocks",
+									pcaddr->chunknos[i], blocknum, global_chunknos[pcaddr->chunknos[i] - 1] - 1, path)));
+
+					/*
+					 * clean all chunk allocation infomation in the two
+					 * duplicated pages
+					 */
+					for (j = 0; j < pcaddr_dup->allocated_chunks; j++)
+					{
+						global_chunknos[pcaddr_dup->chunknos[j] - 1] = 0;
+					}
+					MemSet(pcaddr, 0, SizeOfPageCompressAddr(chunk_size));
+					MemSet(pcaddr_dup, 0, SizeOfPageCompressAddr(chunk_size));
+					continue;
+				}
+				else
+				{
+					pfree(global_chunknos);
+					ereport(ERROR,
+							(errcode(ERRCODE_DATA_CORRUPTED),
+							 errmsg("chunk number %u of block %u duplicate with block %u in file \"%s\"",
+									pcaddr->chunknos[i], blocknum, global_chunknos[pcaddr->chunknos[i] - 1] - 1, path)));
+				}
+			}
+
+			/*
+			 * check if chunkno exceeds size of the pcd file, exceeded chunkno
+			 * will be clean up
+			 */
+			if (pcaddr->chunknos[i] > total_allocated_chunks)
+			{
+				pcaddr->allocated_chunks = i;
+				break;
+			}
+		}
+
+		/*
+		 * clean chunknos beyond allocated_chunks for one page and this is a
+		 * normal scenario
+		 */
+		for (i = pcaddr->allocated_chunks; i < MaxChunksPreCompressedPage(chunk_size); i++)
+		{
+			if (pcaddr->chunknos[i] != 0)
+			{
+				ereport(DEBUG1,
+						(errcode(ERRCODE_DATA_CORRUPTED),
+						 errmsg("clear chunk %u at position %d which beyond allocated_chunks %u of block %u in file \"%s\"",
+								pcaddr->chunknos[i], i + 1, pcaddr->allocated_chunks, blocknum, path)));
+				pcaddr->chunknos[i] = 0;
+			}
+		}
+
+		for (i = 0; i < pcaddr->allocated_chunks; i++)
+		{
+			global_chunknos[pcaddr->chunknos[i] - 1] = blocknum + 1;
+		}
+
+		if (pcaddr->nchunks > 0)
+			real_blocks = blocknum + 1;
+	}
+
+	/* clean the rest of address data in pca file */
+	for (; blocknum < (segno + 1) * ((BlockNumber) RELSEG_SIZE); blocknum++)
+	{
+		char		buf[256],
+				   *p;
+		bool		need_clean = false;
+
+		pcaddr = GetPageCompressAddr(pcmap, chunk_size, blocknum);
+		if (pcaddr->allocated_chunks != 0 || pcaddr->nchunks != 0)
+			need_clean = true;
+
+		/* clean address data and output content of the address */
+		MemSet(buf, 0, sizeof(buf));
+		p = buf;
+
+		for (i = 0; i < MaxChunksPreCompressedPage(chunk_size); i++)
+		{
+			if (pcaddr->chunknos[i])
+			{
+				need_clean = true;
+				if (i == 0)
+					snprintf(p, (sizeof(buf) - (p - buf)), "%u", pcaddr->chunknos[i]);
+				else
+					snprintf(p, (sizeof(buf) - (p - buf)), ",%u", pcaddr->chunknos[i]);
+				p += strlen(p);
+			}
+		}
+
+		if (need_clean)
+		{
+			ereport(WARNING,
+					(errcode(ERRCODE_DATA_CORRUPTED),
+					 errmsg("clean unused address data of block %u in file \"%s\", old allocated_chunks/nchunks/chunknos: %u/%u/{%s}",
+							blocknum, path, pcaddr->allocated_chunks, pcaddr->nchunks, buf)));
+
+			MemSet(pcaddr, 0, SizeOfPageCompressAddr(chunk_size));
+		}
+	}
+
+	/* fix unused chunks via compression data file */
+	for (i = 0; i < total_allocated_chunks; i++)
+	{
+		int			rc;
+		char		buf[SizeOfPageCompressChunkHeaderData + SizeOfPageCompressDataHeaderData];
+		int			nbytes = SizeOfPageCompressChunkHeaderData + SizeOfPageCompressDataHeaderData;
+		PageCompressChunk *pcchunk = (PageCompressChunk *) buf;
+		PageCompressData *pcdata = (PageCompressData *) (buf + SizeOfPageCompressChunkHeaderData);
+
+		if (global_chunknos[i] == 0)
+		{
+			rc = pg_pread(fd_pcd, buf, nbytes, i * chunk_size);
+
+			if (rc < 0)
+			{
+				pfree(global_chunknos);
+				ereport(ERROR,
+						(errcode_for_file_access(),
+						 errmsg("could not read file \"%s\": %m", path_pcd)));
+			}
+
+			if (rc >= 0 && rc != nbytes)
+			{
+				pfree(global_chunknos);
+				ereport(ERROR,
+						(errcode_for_file_access(),
+						 errmsg("could not read file \"%s\": read %d of %d",
+								path_pcd, rc, nbytes)));
+			}
+
+			if (pcchunk->chunkseq > 0 && pcchunk->chunkseq <= MaxChunksPreCompressedPage(chunk_size))
+			{
+				pcaddr = GetPageCompressAddr(pcmap, chunk_size, pcchunk->blockno);
+				if (pcaddr->chunknos[pcchunk->chunkseq - 1] == 0 &&
+					pcaddr->allocated_chunks + 1 == pcchunk->chunkseq)
+				{
+					global_chunknos[i] = pcchunk->blockno + 1;
+					pcaddr->chunknos[pcchunk->chunkseq - 1] = i + 1;
+					pcaddr->allocated_chunks++;
+
+					ereport(LOG,
+							(errcode(ERRCODE_DATA_CORRUPTED),
+							 errmsg("fix allocation of chunk for block %u in file \"%s\", seq: %u, chunkno: %u",
+									pcchunk->blockno, path, pcchunk->chunkseq, i + 1)));
+
+					/*
+					 * After fixing page's nchunks, may cause nchunks to be
+					 * larger than allocated_chunks. This will be fixed when
+					 * replaying WAL record with FPI.
+					 */
+					if (pcchunk->withdata && pcchunk->chunkseq == 1)
+					{
+						int			nchunks = 0;
+
+						nchunks = NeedPageCompressChunksToStoreData(chunk_size, SizeOfPageCompressDataHeaderData + pcdata->size);
+
+						if (nchunks <= MaxChunksPreCompressedPage(chunk_size) && pcaddr->nchunks != nchunks)
+						{
+							ereport(LOG,
+									(errcode(ERRCODE_DATA_CORRUPTED),
+									 errmsg("fix nchunks of block %u in file \"%s\", old: %u, new: %u",
+											pcchunk->blockno, path, pcaddr->nchunks, nchunks)));
+
+							pcaddr->nchunks = nchunks;
+							if ((pcchunk->blockno % RELSEG_SIZE) + 1 > real_blocks)
+								real_blocks = (pcchunk->blockno % RELSEG_SIZE) + 1;
+						}
+					}
+				}
+			}
+		}
+	}
+
+	/* check for holes in allocated chunks */
+	for (i = 0; i < total_allocated_chunks; i++)
+		if (global_chunknos[i] == 0)
+			unused_chunks++;
+
+	if (unused_chunks > 0)
+		ereport(WARNING,
+				(errcode(ERRCODE_DATA_CORRUPTED),
+				 errmsg("there are %u chunks of total allocated chunks %u can not be use in file \"%s\"",
+						unused_chunks, total_allocated_chunks, path),
+				 errhint("You may need to run VACUMM FULL to optimize space allocation, or run REINDEX if it is an index.")));
+
+	/*
+	 * update nblocks in header of page compression address file. Because
+	 * mdextend_pc delays space allocation for new pages, it is normal for the
+	 * number of blocks recorded in the compression address file to be greater
+	 * than the maximum block number in the compression data file. So scenes
+	 * with "real_blocks < nblocks" do not need to be fixed.
+	 */
+	if (real_blocks > nblocks)
+	{
+		pg_atomic_write_u32(&pcmap->nblocks, real_blocks);
+		pg_atomic_write_u32(&pcmap->last_synced_nblocks, real_blocks);
+
+		ereport(LOG,
+				(errcode(ERRCODE_DATA_CORRUPTED),
+				 errmsg("fix nblocks in header of  file \"%s\", old: %u, new: %u",
+						path, nblocks, real_blocks)));
+	}
+
+	/* update allocated_chunks in header of compression address file */
+	if (allocated_chunks != total_allocated_chunks)
+	{
+		pg_atomic_write_u32(&pcmap->allocated_chunks, total_allocated_chunks);
+		pg_atomic_write_u32(&pcmap->last_synced_allocated_chunks, total_allocated_chunks);
+
+		ereport(LOG,
+				(errcode(ERRCODE_DATA_CORRUPTED),
+				 errmsg("fix allocated_chunks in header of file \"%s\", old: %u, new: %u",
+						path, allocated_chunks, total_allocated_chunks)));
+	}
+
+	pfree(global_chunknos);
+
+	if (pc_msync(pcmap) != 0)
+		ereport(data_sync_elevel(ERROR),
+				(errcode_for_dynamic_shared_memory(),
+				 errmsg("could not msync file \"%s\": %m",
+						path)));
+
+	pcmap->last_recovery_start_time = PgStartTime;
+}
diff --git a/src/backend/utils/activity/wait_event.c b/src/backend/utils/activity/wait_event.c
index da57a93034..35a2d87a52 100644
--- a/src/backend/utils/activity/wait_event.c
+++ b/src/backend/utils/activity/wait_event.c
@@ -744,6 +744,12 @@ pgstat_get_wait_io(WaitEventIO w)
 		case WAIT_EVENT_WAL_WRITE:
 			event_name = "WALWrite";
 			break;
+		case WAIT_EVENT_COMPRESS_ADDRESS_FILE_FLUSH:
+			event_name = "CompressAddressFileFlush";
+			break;
+		case WAIT_EVENT_COMPRESS_ADDRESS_FILE_SYNC:
+			event_name = "CompressAddressFileSync";
+			break;
 
 			/* no default case, so that compiler will warn */
 	}
diff --git a/src/backend/utils/adt/dbsize.c b/src/backend/utils/adt/dbsize.c
index 34efa121b4..0198012643 100644
--- a/src/backend/utils/adt/dbsize.c
+++ b/src/backend/utils/adt/dbsize.c
@@ -314,16 +314,58 @@ calculate_relation_size(RelFileLocator *rfn, BackendId backend, ForkNumber forkn
 			snprintf(pathname, MAXPGPATH, "%s.%u",
 					 relationpath, segcount);
 
-		if (stat(pathname, &fst) < 0)
+		if (rfn->compressOpt.algorithm != PAGE_COMPRESSION_NONE &&
+			forknum == MAIN_FORKNUM)
 		{
-			if (errno == ENOENT)
-				break;
-			else
-				ereport(ERROR,
-						(errcode_for_file_access(),
-						 errmsg("could not stat file \"%s\": %m", pathname)));
+			char	   *pcfile_segpath;
+
+			/* calculate size of page compression address file */
+			pcfile_segpath = psprintf("%s_pca", pathname);
+			if (stat(pcfile_segpath, &fst) < 0)
+			{
+				if (errno == ENOENT)
+				{
+					pfree(pcfile_segpath);
+					break;
+				}
+				else
+					ereport(ERROR,
+							(errcode_for_file_access(),
+							 errmsg("could not stat file \"%s\": %m", pcfile_segpath)));
+			}
+			totalsize += fst.st_size;
+			pfree(pcfile_segpath);
+
+			/* calculate size of page compression data file */
+			pcfile_segpath = psprintf("%s_pcd", pathname);
+			if (stat(pcfile_segpath, &fst) < 0)
+			{
+				if (errno == ENOENT)
+				{
+					pfree(pcfile_segpath);
+					break;
+				}
+				else
+					ereport(ERROR,
+							(errcode_for_file_access(),
+							 errmsg("could not stat file \"%s\": %m", pcfile_segpath)));
+			}
+			totalsize += fst.st_size;
+			pfree(pcfile_segpath);
+		}
+		else
+		{
+			if (stat(pathname, &fst) < 0)
+			{
+				if (errno == ENOENT)
+					break;
+				else
+					ereport(ERROR,
+							(errcode_for_file_access(),
+							 errmsg("could not stat file \"%s\": %m", pathname)));
+			}
+			totalsize += fst.st_size;
 		}
-		totalsize += fst.st_size;
 	}
 
 	return totalsize;
diff --git a/src/backend/utils/cache/relcache.c b/src/backend/utils/cache/relcache.c
index bdb771d278..6b5aafb31e 100644
--- a/src/backend/utils/cache/relcache.c
+++ b/src/backend/utils/cache/relcache.c
@@ -30,6 +30,10 @@
 #include <fcntl.h>
 #include <unistd.h>
 
+#include "access/hash.h"
+#include "access/gin_private.h"
+#include "access/gist_private.h"
+#include "access/spgist_private.h"
 #include "access/htup_details.h"
 #include "access/multixact.h"
 #include "access/nbtree.h"
@@ -76,6 +80,7 @@
 #include "rewrite/rewriteDefine.h"
 #include "rewrite/rowsecurity.h"
 #include "storage/lmgr.h"
+#include "storage/page_compression.h"
 #include "storage/smgr.h"
 #include "utils/array.h"
 #include "utils/builtins.h"
@@ -316,6 +321,7 @@ static OpClassCacheEnt *LookupOpclassInfo(Oid operatorClassOid,
 										  StrategyNumber numSupport);
 static void RelationCacheInitFileRemoveInDir(const char *tblspcpath);
 static void unlink_initfile(const char *initfilename, int elevel);
+static void SetupPageCompressForRelation(Relation relation, PageCompressOpts *compress_options);
 
 
 /*
@@ -1381,6 +1387,40 @@ RelationInitPhysicalAddr(Relation relation)
 		else
 			relation->rd_firstRelfilelocatorSubid = InvalidSubTransactionId;
 	}
+
+	/* setup page compression option */
+	if (relation->rd_options)
+	{
+		switch (relation->rd_rel->relam)
+		{
+			case HEAP_TABLE_AM_OID:
+				SetupPageCompressForRelation(relation, &((StdRdOptions *) (relation->rd_options))->compress);
+				break;
+
+			case BTREE_AM_OID:
+				SetupPageCompressForRelation(relation, &((BTOptions *) (relation->rd_options))->compress);
+				break;
+
+			case HASH_AM_OID:
+				SetupPageCompressForRelation(relation, &((HashOptions *) (relation->rd_options))->compress);
+				break;
+
+			case GIN_AM_OID:
+				SetupPageCompressForRelation(relation, &((GinOptions *) (relation->rd_options))->compress);
+				break;
+
+			case GIST_AM_OID:
+				SetupPageCompressForRelation(relation, &((GiSTOptions *) (relation->rd_options))->compress);
+				break;
+
+			case SPGIST_AM_OID:
+				SetupPageCompressForRelation(relation, &((SpGistOptions *) (relation->rd_options))->compress);
+				break;
+
+			default:
+				break;
+		}
+	}
 }
 
 /*
@@ -3464,7 +3504,8 @@ RelationBuildLocalRelation(const char *relname,
 						   bool shared_relation,
 						   bool mapped_relation,
 						   char relpersistence,
-						   char relkind)
+						   char relkind,
+						   Datum reloptions)
 {
 	Relation	rel;
 	MemoryContext oldcxt;
@@ -3641,6 +3682,17 @@ RelationBuildLocalRelation(const char *relname,
 
 	RelationInitPhysicalAddr(rel);
 
+	/* setup page compression option */
+	if (reloptions &&
+		(relkind == RELKIND_RELATION ||
+		 relkind == RELKIND_MATVIEW ||
+		 relkind == RELKIND_INDEX))
+	{
+		StdRdOptions *options = (StdRdOptions *) default_reloptions(reloptions, false, RELOPT_KIND_HEAP);
+
+		SetupPageCompressForRelation(rel, &options->compress);
+	}
+
 	rel->rd_rel->relam = accessmtd;
 
 	/*
@@ -6720,3 +6772,60 @@ unlink_initfile(const char *initfilename, int elevel)
 							initfilename)));
 	}
 }
+
+/* setup page compression options for relation */
+static void
+SetupPageCompressForRelation(Relation relation, PageCompressOpts *compress_options)
+{
+	if (compress_options->compresstype == PAGE_COMPRESSION_NONE)
+	{
+		relation->rd_locator.compressOpt.algorithm = PAGE_COMPRESSION_NONE;
+		relation->rd_locator.compressOpt.level = 0;
+		relation->rd_locator.compressOpt.chunks_pre_block = 0;
+		relation->rd_locator.compressOpt.prealloc_chunks = 0;
+	}
+	else
+	{
+		if (!SUPPORT_PAGE_COMPRESSION)
+			ereport(ERROR,
+					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+					 errmsg("page compression is not supported by this build")));
+
+#ifndef USE_LZ4
+		if (compress_options->compresstype == PAGE_COMPRESSION_LZ4)
+			ereport(ERROR,
+					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+					 errmsg("lz4 compression is not supported by this build")));
+#endif
+
+#ifndef USE_ZSTD
+		if (compress_options->compresstype == PAGE_COMPRESSION_ZSTD)
+			ereport(ERROR,
+					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+					 errmsg("zstd compression is not supported by this build")));
+#endif
+
+		relation->rd_locator.compressOpt.algorithm = compress_options->compresstype;
+		relation->rd_locator.compressOpt.level = compress_options->compresslevel;
+
+		if (compress_options->compress_chunk_size != BLCKSZ / 2 &&
+			compress_options->compress_chunk_size != BLCKSZ / 4 &&
+			compress_options->compress_chunk_size != BLCKSZ / 8 &&
+			compress_options->compress_chunk_size != BLCKSZ / 16)
+		{
+			ereport(ERROR,
+					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+					 errmsg("invalid compress_chunk_size %d, must be one of %d, %d, %d or %d",
+							compress_options->compress_chunk_size,
+							BLCKSZ / 16, BLCKSZ / 8, BLCKSZ / 4, BLCKSZ / 2),
+					 errtable(relation)));
+		}
+
+		relation->rd_locator.compressOpt.chunks_pre_block = BLCKSZ / compress_options->compress_chunk_size;
+
+		if (compress_options->compress_prealloc_chunks >= BLCKSZ / compress_options->compress_chunk_size)
+			relation->rd_locator.compressOpt.prealloc_chunks = (uint8) (BLCKSZ / compress_options->compress_chunk_size - 1);
+		else
+			relation->rd_locator.compressOpt.prealloc_chunks = (uint8) (compress_options->compress_prealloc_chunks);
+	}
+}
diff --git a/src/include/access/gin_private.h b/src/include/access/gin_private.h
index 2935d2f353..3b0189dfcb 100644
--- a/src/include/access/gin_private.h
+++ b/src/include/access/gin_private.h
@@ -18,6 +18,7 @@
 #include "fmgr.h"
 #include "lib/rbtree.h"
 #include "storage/bufmgr.h"
+#include "utils/rel.h"
 
 /*
  * Storage type for GIN's reloptions
@@ -27,6 +28,7 @@ typedef struct GinOptions
 	int32		vl_len_;		/* varlena header (do not touch directly!) */
 	bool		useFastUpdate;	/* use fast updates? */
 	int			pendingListCleanupSize; /* maximum size of pending list */
+	PageCompressOpts	compress; /* page compression related options */
 } GinOptions;
 
 #define GIN_DEFAULT_USE_FASTUPDATE	true
diff --git a/src/include/access/gist_private.h b/src/include/access/gist_private.h
index 240131ef71..b831e69c87 100644
--- a/src/include/access/gist_private.h
+++ b/src/include/access/gist_private.h
@@ -21,6 +21,7 @@
 #include "storage/bufmgr.h"
 #include "storage/buffile.h"
 #include "utils/hsearch.h"
+#include "utils/rel.h"
 #include "access/genam.h"
 
 /*
@@ -396,6 +397,7 @@ typedef struct GiSTOptions
 	int32		vl_len_;		/* varlena header (do not touch directly!) */
 	int			fillfactor;		/* page fill factor in percent (0..100) */
 	GistOptBufferingMode buffering_mode;	/* buffering build mode */
+	PageCompressOpts	compress; /* page compression related options */
 } GiSTOptions;
 
 /* gist.c */
diff --git a/src/include/access/hash.h b/src/include/access/hash.h
index da372841c4..e772c8a5ca 100644
--- a/src/include/access/hash.h
+++ b/src/include/access/hash.h
@@ -26,6 +26,7 @@
 #include "storage/bufmgr.h"
 #include "storage/lockdefs.h"
 #include "utils/hsearch.h"
+#include "utils/rel.h"
 #include "utils/relcache.h"
 
 /*
@@ -270,6 +271,7 @@ typedef struct HashOptions
 {
 	int32		varlena_header_;	/* varlena header (do not touch directly!) */
 	int			fillfactor;		/* page fill factor in percent (0..100) */
+	PageCompressOpts	compress; /* page compression related options */
 } HashOptions;
 
 #define HashGetFillFactor(relation) \
diff --git a/src/include/access/nbtree.h b/src/include/access/nbtree.h
index 93f8267b48..32f6f34534 100644
--- a/src/include/access/nbtree.h
+++ b/src/include/access/nbtree.h
@@ -24,6 +24,7 @@
 #include "lib/stringinfo.h"
 #include "storage/bufmgr.h"
 #include "storage/shm_toc.h"
+#include "utils/rel.h"
 
 /* There's room for a 16-bit vacuum cycle ID in BTPageOpaqueData */
 typedef uint16 BTCycleId;
@@ -1090,6 +1091,7 @@ typedef struct BTOptions
 	int			fillfactor;		/* page fill factor in percent (0..100) */
 	float8		vacuum_cleanup_index_scale_factor;	/* deprecated */
 	bool		deduplicate_items;	/* Try to deduplicate items? */
+	PageCompressOpts	compress; /* page compression related options */
 } BTOptions;
 
 #define BTGetFillFactor(relation) \
diff --git a/src/include/access/spgist_private.h b/src/include/access/spgist_private.h
index eb56b1c6b8..e585244862 100644
--- a/src/include/access/spgist_private.h
+++ b/src/include/access/spgist_private.h
@@ -20,6 +20,7 @@
 #include "nodes/tidbitmap.h"
 #include "storage/buf.h"
 #include "utils/geo_decls.h"
+#include "utils/rel.h"
 #include "utils/relcache.h"
 
 
@@ -27,6 +28,7 @@ typedef struct SpGistOptions
 {
 	int32		varlena_header_;	/* varlena header (do not touch directly!) */
 	int			fillfactor;		/* page fill factor in percent (0..100) */
+	PageCompressOpts	compress; /* page compression related options */
 } SpGistOptions;
 
 #define SpGistGetFillFactor(relation) \
diff --git a/src/include/catalog/heap.h b/src/include/catalog/heap.h
index 5774c46471..401ce71b34 100644
--- a/src/include/catalog/heap.h
+++ b/src/include/catalog/heap.h
@@ -57,6 +57,7 @@ extern Relation heap_create(const char *relname,
 							char relpersistence,
 							bool shared_relation,
 							bool mapped_relation,
+							Datum reloptions,
 							bool allow_system_table_mods,
 							TransactionId *relfrozenxid,
 							MultiXactId *relminmxid,
diff --git a/src/include/storage/checksum.h b/src/include/storage/checksum.h
index 1904fabd5a..fce330da0e 100644
--- a/src/include/storage/checksum.h
+++ b/src/include/storage/checksum.h
@@ -21,4 +21,10 @@
  */
 extern uint16 pg_checksum_page(char *page, BlockNumber blkno);
 
+/*
+ * Compute the checksum for a chunk of compressed page.  The chunk must be
+ * aligned on a 4-byte boundary.
+ */
+extern uint16 pg_checksum_compress_chunk(char *chunk, int chunk_size, uint32 chunckno);
+
 #endif							/* CHECKSUM_H */
diff --git a/src/include/storage/checksum_impl.h b/src/include/storage/checksum_impl.h
index d2eb75f769..94c4434757 100644
--- a/src/include/storage/checksum_impl.h
+++ b/src/include/storage/checksum_impl.h
@@ -101,6 +101,7 @@
  */
 
 #include "storage/bufpage.h"
+#include "storage/page_compression.h"
 
 /* number of checksums to calculate in parallel */
 #define N_SUMS 32
@@ -139,11 +140,11 @@ do { \
 } while (0)
 
 /*
- * Block checksum algorithm.  The page must be adequately aligned
+ * Data checksum algorithm.  The data must be adequately aligned
  * (at least on 4-byte boundary).
  */
 static uint32
-pg_checksum_block(const PGChecksummablePage *page)
+pg_checksum_data(const char *data, int size)
 {
 	uint32		sums[N_SUMS];
 	uint32		result = 0;
@@ -151,15 +152,16 @@ pg_checksum_block(const PGChecksummablePage *page)
 				j;
 
 	/* ensure that the size is compatible with the algorithm */
-	Assert(sizeof(PGChecksummablePage) == BLCKSZ);
+	Assert(size > 0);
+	Assert(chunk_size == (size / (sizeof(uint32) * N_SUMS)) * (sizeof(uint32) * N_SUMS));
 
 	/* initialize partial checksums to their corresponding offsets */
 	memcpy(sums, checksumBaseOffsets, sizeof(checksumBaseOffsets));
 
 	/* main checksum calculation */
-	for (i = 0; i < (uint32) (BLCKSZ / (sizeof(uint32) * N_SUMS)); i++)
+	for (i = 0; i < (uint32) (size / (sizeof(uint32) * N_SUMS)); i++)
 		for (j = 0; j < N_SUMS; j++)
-			CHECKSUM_COMP(sums[j], page->data[i][j]);
+			CHECKSUM_COMP(sums[j], ((uint32 *) data)[i * N_SUMS + j]);
 
 	/* finally add in two rounds of zeroes for additional mixing */
 	for (i = 0; i < 2; i++)
@@ -201,7 +203,7 @@ pg_checksum_page(char *page, BlockNumber blkno)
 	 */
 	save_checksum = cpage->phdr.pd_checksum;
 	cpage->phdr.pd_checksum = 0;
-	checksum = pg_checksum_block(cpage);
+	checksum = pg_checksum_data(page, BLCKSZ);
 	cpage->phdr.pd_checksum = save_checksum;
 
 	/* Mix in the block number to detect transposed pages */
@@ -213,3 +215,42 @@ pg_checksum_page(char *page, BlockNumber blkno)
 	 */
 	return (uint16) ((checksum % 65535) + 1);
 }
+
+
+/*
+ * Compute the checksum for a chunk of compressed page.
+ *
+ * The chunk must be adequately aligned (at least on a 4-byte boundary).
+ * Beware also that the checksum field of the page is transiently zeroed.
+ *
+ * The checksum includes the chunck number (to detect the case where a chunk
+ * is somehow moved to a different location), the chunk header (excluding the
+ * checksum itself), and the chunk data.
+ */
+uint16
+pg_checksum_compress_chunk(char *chunk, int chunk_size, uint32 chunckno)
+{
+	PageCompressChunk *pcchunk = (PageCompressChunk *) chunk;
+	uint16		save_checksum;
+	uint32		checksum;
+
+	/*
+	 * Save pd_checksum and temporarily set it to zero, so that the checksum
+	 * calculation isn't affected by the old checksum stored on the page.
+	 * Restore it after, because actually updating the checksum is NOT part of
+	 * the API of this function.
+	 */
+	save_checksum = pcchunk->checksum;
+	pcchunk->checksum = 0;
+	checksum = pg_checksum_data(chunk, chunk_size);
+	pcchunk->checksum = save_checksum;
+
+	/* Mix in the chunk number to detect transposed pages */
+	checksum ^= chunckno;
+
+	/*
+	 * Reduce to a uint16 (to fit in the checksum field) with an offset of
+	 * one. That avoids checksums of zero, which seems like a good idea.
+	 */
+	return (uint16) ((checksum % 65535) + 1);
+}
diff --git a/src/include/storage/fd.h b/src/include/storage/fd.h
index 2b4a8e0ffe..a6e73433e9 100644
--- a/src/include/storage/fd.h
+++ b/src/include/storage/fd.h
@@ -156,6 +156,10 @@ extern void ReleaseExternalFD(void);
 /* Make a directory with default permissions */
 extern int	MakePGDirectory(const char *directoryName);
 
+/* Page compression support routines */
+extern void SetupPageCompressMemoryMap(File file, File file_pcd, int chunk_size, uint8 algorithm);
+extern void *GetPageCompressMemoryMap(File file, int chunk_size);
+
 /* Miscellaneous support routines */
 extern void InitFileAccess(void);
 extern void InitTemporaryFileAccess(void);
